Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.4.18.1
retrieving revision 1.4.18.1.4.1
diff -u -r1.4.18.1 -r1.4.18.1.4.1
--- squid/src/store_dir.c	17 Dec 2000 13:55:39 -0000	1.4.18.1
+++ squid/src/store_dir.c	17 Dec 2000 14:36:24 -0000	1.4.18.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.4.18.1 2000/12/17 13:55:39 hno Exp $
+ * $Id: store_dir.c,v 1.4.18.1.4.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -48,10 +48,8 @@
 void
 storeDirInit(void)
 {
-    int i;
     SwapDir *sd;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	sd = &Config.cacheSwap.swapDirs[i];
+    FOREACHSD( sd ) {
 	sd->init(sd);
     }
     if (0 == strcasecmp(Config.store_dir_select_algorithm, "round-robin")) {
@@ -66,14 +64,14 @@
 void
 storeCreateSwapDirectories(void)
 {
-    int i;
     SwapDir *sd;
     pid_t pid;
     int status;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+    FOREACHSD( sd ) {
+	if( sd -> flags.offline )
+	    continue;
 	if (fork())
 	    continue;
-	sd = &Config.cacheSwap.swapDirs[i];
 	sd->newfs(sd);
 	exit(0);
     }
@@ -136,7 +134,11 @@
 	if (++dirn >= Config.cacheSwap.n_configured)
 	    dirn = 0;
 	sd = &Config.cacheSwap.swapDirs[dirn];
-	if (sd->cur_size > sd->max_size)
+	if ((sd->cur_size > sd->max_size) 
+#if defined( DISK_REPL )
+	    || sd->flags.offline
+#endif
+	    )
 	    continue;
 	break;
     }
@@ -146,9 +148,15 @@
        act together like hash buckets.  They use a hash based on URL
        to select which dir the object should go to -- this allows to
        have only one open() in storeTreeGet(). */
+    debug( 47, 9 )( "storeDirSelectSwapDirRoundRobin: fdirn: %i\n", dirn );
+    /* may be we should not store re-selected cache_dir index back into
+       dirn? Otherwise, if we have mixture of storetree and usual 
+       caches, round-robin will somewhat stuck into storetree,
+       giving unfair amount of load to it? --nikita */
     if (sd->reselectdir)
 	dirn = sd->reselectdir(e)->index;
 #endif
+    debug( 47, 9 )( "storeDirSelectSwapDirRoundRobin: dirn: %i\n", dirn );
     return dirn;
 }
 
@@ -184,9 +192,13 @@
     /* Initial defaults */
     least_size = Config.cacheSwap.swapDirs[0].cur_size;
     least_objsize = Config.cacheSwap.swapDirs[0].max_objsize;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+    FOREACHSDINDEX( i ) {
 	SD = &Config.cacheSwap.swapDirs[i];
 	SD->flags.selected = 0;
+#if defined( DISK_REPL )
+	if (SD->flags.offline)
+	    continue;
+#endif
 	if (SD->flags.read_only)
 	    continue;
 	/* Valid for object size check */
@@ -212,6 +224,7 @@
     if (dirn >= 0)
 	Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
 
+    debug( 47, 9 )( "storeDirSelectSwapDirLeastLoad: dirn: %i\n", dirn );
     return dirn;
 }
 
@@ -251,7 +264,10 @@
 	e->swap_dirn,
 	e->swap_filen);
     sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
-    sd->log.write(sd, e, op);
+    if( !sd -> flags.offline )
+      {
+	sd->log.write(sd, e, op);
+      }
 }
 
 void
@@ -284,7 +300,7 @@
 	percent((int) (Config.Swap.maxSize - store_swap_size), (int) Config.Swap.maxSize));
 
     /* Now go through each swapdir, calling its statfs routine */
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+    FOREACHSDINDEX( i ) {
 	storeAppendPrintf(sentry, "\n");
 	SD = &(Config.cacheSwap.swapDirs[i]);
 	storeAppendPrintf(sentry, "Store Directory #%d (%s): %s\n", i, SD->type,
@@ -297,10 +313,8 @@
 storeDirConfigure(void)
 {
     SwapDir *SD;
-    int i;
     Config.Swap.maxSize = 0;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];
+    FOREACHSD( SD ) {
 	Config.Swap.maxSize += SD->max_size;
 	SD->low_size = (int) (((float) SD->max_size *
 		(float) Config.Swap.lowWaterMark) / 100.0);
@@ -322,10 +336,12 @@
 void
 storeDirOpenSwapLogs(void)
 {
-    int dirn;
     SwapDir *sd;
-    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	sd = &Config.cacheSwap.swapDirs[dirn];
+    FOREACHSD( sd ) {
+	if( sd -> flags.offline )
+	  {
+	    continue;
+	  }
 	sd->log.open(sd);
     }
 }
@@ -333,10 +349,12 @@
 void
 storeDirCloseSwapLogs(void)
 {
-    int dirn;
     SwapDir *sd;
-    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	sd = &Config.cacheSwap.swapDirs[dirn];
+    FOREACHSD( sd ) {
+	if( sd -> flags.offline )
+	  {
+	    continue;
+	  }
 	sd->log.close(sd);
     }
 }
@@ -360,7 +378,6 @@
     double dt;
     SwapDir *sd;
     RemovalPolicyWalker **walkers;
-    int dirn;
     int notdone = 1;
     if (store_dirs_rebuilding) {
 	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
@@ -371,8 +388,11 @@
     getCurrentTime();
     start = current_time;
     walkers = xcalloc(Config.cacheSwap.n_configured, sizeof *walkers);
-    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	sd = &Config.cacheSwap.swapDirs[dirn];
+    FOREACHSD( sd ) {
+	if( sd -> flags.offline )
+	  {
+	    continue;
+	  }
 	if (sd->log.clean.start(sd) < 0) {
 	    debug(20, 1) ("log.clean.start() failed for dir #%d\n", sd->index);
 	    continue;
@@ -380,8 +400,11 @@
     }
     while (notdone) {
 	notdone = 0;
-	for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	    sd = &Config.cacheSwap.swapDirs[dirn];
+	FOREACHSD( sd ) {
+	    if( sd -> flags.offline )
+	      {
+		continue;
+	      }
 	    if (NULL == sd->log.clean.write)
 		continue;
 	    e = sd->log.clean.nextentry(sd);
@@ -408,8 +431,11 @@
 	}
     }
     /* Flush */
-    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	sd = &Config.cacheSwap.swapDirs[dirn];
+    FOREACHSD( sd ) {
+	if( sd -> flags.offline )
+	  {
+	    continue;
+	  }
 	sd->log.clean.done(sd);
     }
     if (reopen)
@@ -429,11 +455,13 @@
 void
 storeDirSync(void)
 {
-    int i;
     SwapDir *SD;
 
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];
+    FOREACHSD( SD ) {
+	if( SD -> flags.offline )
+	  {
+	    continue;
+	  }
 	if (SD->sync != NULL)
 	    SD->sync(SD);
     }
@@ -450,12 +478,16 @@
     static int ndir = 0;
     do {
 	j = 0;
-	for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+	FOREACHSDINDEX( i ) {
 	    if (ndir >= Config.cacheSwap.n_configured)
 		ndir = ndir % Config.cacheSwap.n_configured;
 	    SD = &Config.cacheSwap.swapDirs[ndir++];
 	    if (NULL == SD->callback)
 		continue;
+	    if( SD -> flags.offline )
+	      {
+		continue;
+	      }
 	    j += SD->callback(SD);
 	}
     } while (j > 0);
Index: squid/src/store_io.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_io.c,v
retrieving revision 1.2
retrieving revision 1.2.26.1
diff -u -r1.2 -r1.2.26.1
--- squid/src/store_io.c	21 Oct 2000 15:16:13 -0000	1.2
+++ squid/src/store_io.c	17 Dec 2000 14:36:24 -0000	1.2.26.1
@@ -62,13 +62,18 @@
     void *callback_data)
 {
     SwapDir *SD = &Config.cacheSwap.swapDirs[e->swap_dirn];
-    return SD->obj.open(SD, e, file_callback, callback, callback_data);
+    if( SD -> flags.offline )
+      return NULL;
+    else
+      return SD->obj.open(SD, e, file_callback, callback, callback_data);
 }
 
 void
 storeClose(storeIOState * sio)
 {
     SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
+    if( SD -> flags.offline )
+      return;
     if (sio->flags.closing)
 	return;
     sio->flags.closing = 1;
@@ -79,6 +84,8 @@
 storeRead(storeIOState * sio, char *buf, size_t size, off_t offset, STRCB * callback, void *callback_data)
 {
     SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
+    if( SD -> flags.offline )
+      return;
     SD->obj.read(SD, sio, buf, size, offset, callback, callback_data);
 }
 
@@ -86,6 +93,8 @@
 storeWrite(storeIOState * sio, char *buf, size_t size, off_t offset, FREE * free_func)
 {
     SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
+    if( SD -> flags.offline )
+      return;
     SD->obj.write(SD, sio, buf, size, offset, free_func);
 }
 
@@ -93,6 +102,8 @@
 storeUnlink(StoreEntry * e)
 {
     SwapDir *SD = INDEXSD(e->swap_dirn);
+    if( SD -> flags.offline )
+      return;
     SD->obj.unlink(SD, e);
 }
 
Index: squid/src/store_swapout.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapout.c,v
retrieving revision 1.4.14.1.2.1
retrieving revision 1.4.14.1.2.1.4.1
diff -u -r1.4.14.1.2.1 -r1.4.14.1.2.1.4.1
--- squid/src/store_swapout.c	17 Dec 2000 13:55:39 -0000	1.4.14.1.2.1
+++ squid/src/store_swapout.c	17 Dec 2000 14:36:24 -0000	1.4.14.1.2.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapout.c,v 1.4.14.1.2.1 2000/12/17 13:55:39 hno Exp $
+ * $Id: store_swapout.c,v 1.4.14.1.2.1.4.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapout Functions
  * AUTHOR: Duane Wessels
@@ -280,7 +280,7 @@
     assert(e->swap_status == SWAPOUT_WRITING);
     cbdataFree(c);
     if (errflag) {
-	debug(20, 1) ("storeSwapOutFileClosed: dirno %d, swapfile %08X, errflag=%d\n\t%s\n",
+	debug(20, 1) ("storeSwapOutFileClosed: dirno %d, swapfile %08X, errflag=%d: %s\n",
 	    e->swap_dirn, e->swap_filen, errflag, xstrerror());
 	if (errflag == DISK_NO_SPACE_LEFT) {
 	    storeDirDiskFull(e->swap_dirn);
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.8.8.1.2.1
retrieving revision 1.8.8.1.2.1.2.1
diff -u -r1.8.8.1.2.1 -r1.8.8.1.2.1.2.1
--- squid/src/structs.h	17 Dec 2000 14:09:08 -0000	1.8.8.1.2.1
+++ squid/src/structs.h	17 Dec 2000 14:36:24 -0000	1.8.8.1.2.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.8.8.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: structs.h,v 1.8.8.1.2.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -463,6 +463,9 @@
 	SwapDir *swapDirs;
 	int n_allocated;
 	int n_configured;
+#if defined( DISK_REPL )
+	int n_offline;
+#endif
     } cacheSwap;
     char *fake_ua;
     struct {
@@ -517,6 +520,11 @@
 	size_t high_memory;
     } warnings;
     char *store_dir_select_algorithm;
+#if defined( DISK_REPL )
+  wordlist *disk_repl_watch_list;
+  char *offline_notify_cmd;
+  char *online_notify_cmd;
+#endif
 };
 
 struct _SquidConfig2 {
@@ -628,6 +636,9 @@
     DEFER *defer_check;		/* check if we should defer read */
     void *defer_data;
     CommWriteStateData *rwstate;	/* State data for comm_write */
+#if defined( DISK_REPL )
+    int swap_dir;
+#endif
 };
 
 struct _fileMap {
@@ -1360,6 +1371,7 @@
     struct {
 	unsigned int selected:1;
 	unsigned int read_only:1;
+	unsigned int offline:1;
     } flags;
     STINIT *init;		/* Initialise the fs */
     STNEWFS *newfs;		/* Create a new fs */
@@ -1374,6 +1386,10 @@
     STUNREFOBJ *unrefobj;	/* Unreference this object */
     STCALLBACK *callback;	/* Handle pending callbacks */
     STSYNC *sync;		/* Sync the directory */
+#if defined( DISK_REPL )
+    STONOFF *offline;		/* Go offline */
+    STONOFF *online;		/* Go online */
+#endif
     /* The following are for storetree */
     STHALFRELEASE *halfrelease;	/* Release StoreEntry but keep disk object */
     STRESELECTDIR *reselectdir; /* Swap dir redirection function */
@@ -1398,6 +1414,14 @@
 	} clean;
 	int writes_since_clean;
     } log;
+#if defined( DISK_REPL )
+  struct 
+  {
+    int offline_errno;
+    int errno_threshold;
+    int errnos_detected;
+  } raid;
+#endif
     void *fsdata;
 };
 
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.4.10.1.2.1.2.1
retrieving revision 1.4.10.1.2.1.2.1.2.1
diff -u -r1.4.10.1.2.1.2.1 -r1.4.10.1.2.1.2.1.2.1
--- squid/src/typedefs.h	17 Dec 2000 14:09:08 -0000	1.4.10.1.2.1.2.1
+++ squid/src/typedefs.h	17 Dec 2000 14:36:24 -0000	1.4.10.1.2.1.2.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.4.10.1.2.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: typedefs.h,v 1.4.10.1.2.1.2.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -247,6 +247,7 @@
 typedef void STDONE(void);
 typedef int STCALLBACK(SwapDir *);
 typedef void STSYNC(SwapDir *);
+typedef int  STONOFF(SwapDir *);
 typedef void STHALFRELEASE(StoreEntry *);
 typedef SwapDir *STRESELECTDIR(const StoreEntry *);
 
@@ -319,7 +320,22 @@
 /* 
  * comm_cio.h
  */
- typedef int ( *CioCallback ) ( siginfo_t *info );
+typedef int ( *CioCallback ) ( siginfo_t *info );
 
+typedef syscallcb_result ( *SyscallCallBack )( syscall_type call,
+											   int fd, int *errNo,
+											   void *data );
+typedef struct {
+  SyscallCallBack cb;
+  void *data;
+} SyscallCBInvoc;
+
+#if defined( DISK_REPL )
+typedef struct {
+  int    swapDirNo;
+  time_t crashTime;
+} SimulateCrashData;
+/* DISK_REPL */
+#endif
 
 #endif /* _TYPEDEFS_H_ */
Index: squid/src/wais.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wais.c,v
retrieving revision 1.3.16.1.4.1
retrieving revision 1.3.16.1.4.1.2.1
diff -u -r1.3.16.1.4.1 -r1.3.16.1.4.1.2.1
--- squid/src/wais.c	17 Dec 2000 14:09:08 -0000	1.3.16.1.4.1
+++ squid/src/wais.c	17 Dec 2000 14:36:24 -0000	1.3.16.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wais.c,v 1.3.16.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: wais.c,v 1.3.16.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 24    WAIS Relay
  * AUTHOR: Harvest Derived
@@ -103,7 +103,7 @@
     read_sz = delayBytesWanted(delay_id, 1, read_sz);
 #endif
     statCounter.syscalls.sock.reads++;
-    len = read(fd, buf, read_sz);
+    len = comm_read_wrapper(fd, buf, read_sz);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 #if DELAY_POOLS
@@ -119,13 +119,11 @@
 	for (clen = len - 1, bin = 0; clen; bin++)
 	    clen >>= 1;
 	IOStats.Wais.read_hist[bin]++;
-	CLEAR_CAN_READ_IF_EMPTY( read_sz, len, fd );
     }
     if (len < 0) {
 	debug(50, 1) ("waisReadReply: FD %d: read failure: %s.\n",
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
-	  CLEAR_CAN_READ( fd );
 	    /* reinstall handlers */
 	    /* XXX This may loop forever */
 	    commSetSelect(fd, COMM_SELECT_READ,
Index: squid/src/whois.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/whois.c,v
retrieving revision 1.3.16.1.4.1
retrieving revision 1.3.16.1.4.1.2.1
diff -u -r1.3.16.1.4.1 -r1.3.16.1.4.1.2.1
--- squid/src/whois.c	17 Dec 2000 14:09:08 -0000	1.3.16.1.4.1
+++ squid/src/whois.c	17 Dec 2000 14:36:24 -0000	1.3.16.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: whois.c,v 1.3.16.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: whois.c,v 1.3.16.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 75    WHOIS protocol
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -92,7 +92,7 @@
     MemObject *mem = entry->mem_obj;
     int len;
     statCounter.syscalls.sock.reads++;
-    len = read(fd, buf, 4095);
+    len = comm_read_wrapper(fd, buf, 4095);
     buf[len] = '\0';
     debug(75, 3) ("whoisReadReply: FD %d read %d bytes\n", fd, len);
     debug(75, 5) ("{%s}\n", buf);
@@ -104,12 +104,10 @@
 	kb_incr(&statCounter.server.http.kbytes_in, len);
 	storeAppend(entry, buf, len);
 	commSetSelect(fd, COMM_SELECT_READ, whoisReadReply, p, Config.Timeout.read);
-	CLEAR_CAN_READ_IF_EMPTY( 4095, len, fd );
     } else if (len < 0) {
 	debug(50, 2) ("whoisReadReply: FD %d: read failure: %s.\n",
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
-	  CLEAR_CAN_READ( fd );
 	  commSetSelect(fd, COMM_SELECT_READ, whoisReadReply, p, Config.Timeout.read);
 	} else if (mem->inmem_hi == 0) {
 	    ErrorState *err;
Index: squid/src/fs/butterfly/store_dir_bf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/butterfly/Attic/store_dir_bf.c,v
retrieving revision 1.1.2.1.2.1
retrieving revision 1.1.2.1.2.1.2.1
diff -u -r1.1.2.1.2.1 -r1.1.2.1.2.1.2.1
--- squid/src/fs/butterfly/store_dir_bf.c	17 Dec 2000 14:09:08 -0000	1.1.2.1.2.1
+++ squid/src/fs/butterfly/store_dir_bf.c	17 Dec 2000 14:36:24 -0000	1.1.2.1.2.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir_bf.c,v 1.1.2.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: store_dir_bf.c,v 1.1.2.1.2.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 86    Store Directory, the "Butterfly" version
  * AUTHOR: Yury Shevchuk <sizif@botik.ru>
@@ -54,6 +54,7 @@
 };
 
 int n_bf_dirs = 0;
+int n_bf_offline = 0;
 static int *bf_dir_index = NULL;
 MemPool *bf_state_pool = NULL;
 MemPool *bf_op_pool = NULL;
@@ -73,6 +74,10 @@
 static void storeBfDirInit(SwapDir * sd);
 static void storeBfStats(StoreEntry * sentry);
 static void storeBfDirSync(SwapDir * SD);
+#if defined( DISK_REPL )
+static int storeBfDirOffline(SwapDir * SD);
+static int storeBfDirOnline(SwapDir * SD);
+#endif
 static int  storeBfDirCallback(SwapDir * SD);
 static void storeBfRelease(StoreEntry *e);
 static SwapDir *storeBfReselectDir (const StoreEntry *e);
@@ -92,6 +97,7 @@
 static void storeBfDirFree(SwapDir * s);
 static int  storeBfCleanupDoubleCheck(SwapDir * sd, StoreEntry * e);
 static void storeBfDirParse(SwapDir * sd, int index, char *path);
+static int findNthBf( int n );
 
 
 int
@@ -227,28 +233,47 @@
 	snprintf(aio_nthreads, sizeof(aio_nthreads), "%d", bf_nthreads);
 	setenv(AIO_THREAD_ENVIRON, aio_nthreads, 0);
     }
-    if (storeBfDirVerifyCacheDirs(sd) < 0)
+    if (storeBfDirVerifyCacheDirs(sd) < 0) {
+#if defined( DISK_REPL )
+	sd -> flags.offline = 1;
+	bfi->dir = -1;
+#else
 	fatal(errmsg);
-
-    bfi->dir = open (sd->path, O_RDONLY);
-    if (bfi->dir < 0) {
+#endif
+    } else {
+      bfi->dir = open (sd->path, O_RDONLY);
+      if (bfi->dir < 0) {
 	debug(50, 0) ("storeBfInit: open(%s): %s\n", sd->path, xstrerror());
+#if defined( DISK_REPL )
+	sd -> flags.offline = 1;
+#else
 	fatal ("cache_dir open failed");
-    }
+#endif
+      }
+      else
+	{
 #if 0				/* TODO: consider legalizing dir fd? */
-    fd_note(bfi->dir, sd->path);
-    commSetTimeout(bfi->dir, -1, NULL, NULL);
-    commSetNonBlocking(bfi->dir);
-#endif
-    /* We are doing polled I/O, don't wait too long in comm_poll */
-    comm_quick_poll_required();
-    storeBfDirOpenSwapLog(sd);
-    storeBfDirRebuild(sd);
+      fd_note(bfi->dir, sd->path);
+      commSetTimeout(bfi->dir, -1, NULL, NULL);
+      commSetNonBlocking(bfi->dir);
+#endif
+      /* We are doing polled I/O, don't wait too long in comm_poll */
+      comm_quick_poll_required();
+      storeBfDirOpenSwapLog(sd);
+      storeBfDirRebuild(sd);
+	}
+    }
 #if 0 && defined( TCP_ASYNC )
     debug(50, 0) ("storeBfDirInit: commCioAddCB\n");
     commCioAddCB( SIGBUTTERFLY, storeBfDirCioCallback );
 /* TCP_ASYNC */
 #endif
+#if defined( DISK_REPL )
+    sd -> raid.offline_errno = DISK_DIES_ERRNO;
+    sd -> raid.errno_threshold = 2;
+    sd -> raid.errnos_detected = 0;
+#endif
+    assert( n_bf_dirs >= 0 );
 }
 
 
@@ -301,6 +326,50 @@
 #endif
 }
 
+#if defined( DISK_REPL )
+static int storeBfDirOffline(SwapDir * SD)
+{
+  bfinfo_t *bfi = SD -> fsdata;
+
+  assert( SD != NULL );
+  debug( 86, 9 ) ( "storeBfDirOffline: offline: %i total: %i\n",
+		   n_bf_offline, n_bf_dirs );
+
+  close( bfi -> dir );
+  bfi -> dir = -1;
+
+  ++n_bf_offline;
+  if( 0 >= n_bf_dirs )
+    {
+      debug( 86, 8 ) ( "storeBfDirOffline: all Butterfly dirs are gone.\n" );
+    }
+  return 1;
+}
+
+static int storeBfDirOnline(SwapDir * SD)
+{
+  bfinfo_t *bfi = SD -> fsdata;
+
+  assert( SD != NULL );
+  assert( n_bf_offline >= 0 );
+  
+  bfi -> dir = open( SD -> path, O_RDONLY );
+  if( bfi -> dir < 0 )
+    {
+      debug(50, 0) ("storeBfDirOnline: open(%s): %s\n", 
+		    SD -> path, xstrerror() );
+      return 0;
+    }
+  else
+    {
+      --n_bf_offline;
+      assert( n_bf_offline >= 0 );
+      return 1;
+    }
+}
+
+#endif
+
 /* Write down op duration profiling data */
 
 static void
@@ -451,7 +520,7 @@
 static SwapDir *
 storeBfReselectDir (const StoreEntry *e)
 {
-    return INDEXSD(storeBfSelectSwapDir(e));
+  return INDEXSD(storeBfSelectSwapDir(e));
 }
 
 
@@ -575,6 +644,11 @@
 	return NULL;
     if (strncasecmp (url, "cache_object://", sizeof "cache_object://"-1) == 0)
 	return NULL;
+#if defined( DISK_REPL )
+    if (n_storetree_dirs <= n_bf_offline)
+	return NULL;
+#endif
+
 
     debug(86, 5) ("StoreTreeGet for %s %s  Callers %p %p %p %p\n", url,
 		  storeKeyText (key),
@@ -678,41 +752,124 @@
 static int
 storeBfSelectSwapDir(const StoreEntry * e)
 {
-    int dirn;
-    int x;
-
+    int shift;
+    
     if (! e->id_valid) {
 	assert (e->mem_obj);
 	assert (e->mem_obj->url);
-	e->id = make_id (e->key, e->mem_obj->url, strlen (e->mem_obj->url));
-	e->id_valid = 1;
-    }
-
-    x = *(unsigned *)e->key % n_bf_dirs;
-    
-    if (Config.cacheSwap.n_configured == n_bf_dirs)
-	return x;
-    else for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	SwapDir *sd = INDEXSD(dirn);
-	if (storeBfDirIs(sd)) {
-	    if (x == 0)
+	/* To avoid constness complaints from cc */
+	((StoreEntry *)e)->id = make_id 
+	  (e->key, e->mem_obj->url, strlen (e->mem_obj->url));
+	((StoreEntry *)e)->id_valid = 1;
+    }
+
+    /* it is not very clean way of coding (it is not clean at all) 
+       but keep with it just for the time being (and being and being and...) */
+    /* This was updated to handle case when some disks are offline.
+       We take each sizeof( unsigned int ) chars from MD5 checksum of
+       URL, divide it to the number of configured butterfly cache_dirs
+       and see if it points to the online dir. If it is not we just
+       move to the next char, otherwise return this dir.
+    */
+    for( shift = 0 ; shift < MD5_DIGEST_CHARS - sizeof( unsigned ) ; ++shift )
+      {
+	int dirn;
+	int x;
+
+	/* n_bf_dirs is decremented when cache goes offline.
+	   n_bf_dirs + n_bf_offline is invariant */
+	x = *(unsigned *)(e->key + shift) % ( n_bf_dirs + n_bf_offline );
+	/* All caches are butterfly and all of them are online. Normal case. */
+	if((Config.cacheSwap.n_configured == n_bf_dirs) && 
+	   (n_bf_offline == 0))
+	  {
+	    debug( 91, 9 ) ("storeBfSelectSwapDir(shortcut): dirn: %i\n", x );
+	    return x;
+	  }
+	/* Some cache_dirs are offline */
+	else if( n_bf_dirs > 0 )
+	  {
+	    dirn = findNthBf( x );
+	    assert( dirn >= 0 );
+#if defined( DISK_REPL )
+	    if( !INDEXSD(dirn) -> flags.offline )
+	      {
 		return dirn;
-	    x--;
+	      }
+	    else
+	      {
+		/* try next portion of md5 */
+		debug( 91, 9 ) 
+		  ("storeBfSelectSwapDir: skipped dirn: %i(%i:%i:%i)\n", 
+		   dirn, x, *(unsigned *)( e -> key + shift ),
+		   n_bf_dirs + n_bf_offline );
+		continue;
+	      }
+#else
+	    return dirn;
+#endif
+	  }
+	/* All butterfly caches are offline. */
+	else
+	  { 
+	    break;
+	  } 
+      }
+    /* 
+       All butterfly caches are offline or we tried all possible
+       hashes and always hit offline dir. Forget about load balancing
+       etc., and just return the first online butterfly directory that
+       we can find.  The frequency of this code being invoked should
+       be very small, causing insignificant distortion of optimal load
+       balancing. --hans
+    */
+    if( n_bf_dirs > 0 )
+      {
+	SwapDir *sd;
+
+	FOREACHSD( sd )
+	  {
+	    if( storeBfDirIs( sd ) && sd -> flags.offline )
+	      {
+		return sd -> index;
+	      }
+	  }
+	assert( 0 );
+	return 0;
+      }
+    else
+      {
+	/* As a last resort try to use any online cache whatsover. */
+	/* Will assert(0) if there are no online caches. */
+	return findFirstOnlineSD();
+      }
+}
+
+static int findNthBf( int n )
+{
+  SwapDir *sd;
+
+  FOREACHSD( sd ) 
+    {
+      if( storeBfDirIs( sd ) )
+	{
+	  if( n == 0 )
+	    {
+	      return sd -> index;
+	    }
+	  n--;
 	}
     }
-    assert (0);
-    return 0;
+  return -1;
 }
 
-
 /*
  * storeBfDirRefObj
  *
  * This routine is called whenever an object is referenced, so we can
  * maintain replacement information within the storage fs.
  *
- * TODO put reiserfs_raw setattr here!
- */
+ * TODO put reiserfs_raw setattr here!  */
 static void
 storeBfDirRefObj(SwapDir *sd, StoreEntry * e)
 {
@@ -943,6 +1100,10 @@
     sd->unrefobj = storeBfDirUnrefObj;
     sd->callback = storeBfDirCallback;
     sd->sync = storeBfDirSync;
+#if defined( DISK_REPL )
+    sd->online = storeBfDirOnline;
+    sd->offline = storeBfDirOffline;
+#endif
     sd->halfrelease = storeBfRelease;
     sd->reselectdir = storeBfReselectDir;
     sd->obj.create = storeBfCreate;
@@ -1003,9 +1164,57 @@
 
 /*
  * $Log: store_dir_bf.c,v $
+ * Revision 1.1.2.1.2.1.2.1  2000/12/17 14:36:24  hno
+ * Imported raid from squidng
+ *
  * Revision 1.1.2.1.2.1  2000/12/17 14:09:08  hno
  * Imported tcp_async from squidng
  *
+ * --- below are from squidng ---
+ *
+ * Revision 1.1.2.7.2.3.2.12  2000/12/07 16:49:31  nikitadanilov
+ * storeBfDirInit: asserts and n_bf_dirs handling corrected (Sizif noted that 
+ * it crashed if first dir was initially offline)
+ *
+ * Revision 1.1.2.7.2.3.2.11  2000/11/28 16:01:39  nikitadanilov
+ * Missing braces (noted by Sizif) inserted.
+ *
+ * Revision 1.1.2.7.2.3.2.10  2000/11/28 11:52:16  sizif
+ * Missing {}s in the recent change
+ *
+ * Revision 1.1.2.7.2.3.2.9  2000/11/27 19:55:56  nikitadanilov
+ * if storeBfDirVerifyCacheDirs() returns -1 just mark cache_dir as offline,
+ * don't bail
+ *
+ * Revision 1.1.2.7.2.3.2.8  2000/11/24 20:43:34  nikitadanilov
+ * If Butterfly cache_dir is inaccessible during startup, mark it offline, not
+ * bail out (NOT TESTED)
+ *
+ * Revision 1.1.2.7.2.3.2.7  2000/11/22 14:49:01  nikitadanilov
+ * Online/offline callbacks improved. Hash function changed for new semantics 
+ * of n_bf_dirs and n_bf_offline
+ *
+ * Revision 1.1.2.7.2.3.2.6  2000/10/20 12:05:04  nikitadanilov
+ * Correct invalid return value from storeBfSelectSwapDir() when compiled w/o 
+ * DISK_REPL
+ *
+ * Revision 1.1.2.7.2.3.2.5  2000/10/19 09:59:48  nikitadanilov
+ * storeBfSelectSwapDir corrected
+ *
+ * Revision 1.1.2.7.2.3.2.4  2000/10/17 19:44:00  nikitadanilov
+ * Move .raid initialisation into storeBfDirInit()
+ *
+ * Revision 1.1.2.7.2.3.2.3  2000/10/17 19:31:26  nikitadanilov
+ * storeBfSelectSwapDir() should be more stable to disk crashes
+ *
+ * Revision 1.1.2.7.2.3.2.2  2000/10/13 15:43:19  nikitadanilov
+ * RAID disk replcement changes: added per-fs callbacks called on on/of-line s
+ * witch; Crash simulation added; Code commented. It started to work (with
+ * crash simulation). Alpha release state reached.
+ *
+ * Revision 1.1.2.7.2.3.2.1  2000/10/12 21:02:21  nikitadanilov
+ * Prototype of put-disk-offline-on-the-fly sub-system
+ *
  * Revision 1.1.2.7.2.3  2000/10/12 15:06:25  nikitadanilov
  * Small typo corrected
  *
Index: squid/src/fs/butterfly/store_io_bf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/butterfly/Attic/store_io_bf.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.1.4.1
diff -u -r1.1.2.1 -r1.1.2.1.4.1
--- squid/src/fs/butterfly/store_io_bf.c	17 Dec 2000 13:55:40 -0000	1.1.2.1
+++ squid/src/fs/butterfly/store_io_bf.c	17 Dec 2000 14:36:24 -0000	1.1.2.1.4.1
@@ -1,5 +1,5 @@
 
-/* $Id: store_io_bf.c,v 1.1.2.1 2000/12/17 13:55:40 hno Exp $
+/* $Id: store_io_bf.c,v 1.1.2.1.4.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 81   Butterfly cache_dir I/O functions.
  * Written by Yury Shevchuk <sizif@botik.ru>
@@ -563,6 +563,15 @@
 	    sio->e->swap_file_sz = bfstate->ra.size;
 	    store_open_disk_fd++;
 	    debug(81, 4) ("storeBfOpCompletion: sio %p fd %d opened\n", sio, bfstate->fd);
+#if defined( DISK_REPL )
+	    fd_table[ bfstate->fd ].swap_dir = sio -> swap_dirn;
+#endif
+	    debug( 81, 9 )( "butterfly fd: %i in swap_dir: %i\n", 
+			    bfstate->fd, sio -> swap_dirn );
+	    if( op -> type == BFCREAT )
+	      {
+		fd_note( bfstate->fd, "Butterfly KAIO" );
+	      }
 	}
 	break;
 
@@ -572,6 +581,18 @@
 	rlen = (x == 0)? aio_return (&op->aio): -1;
 	op->rlen = (x == 0)? aio_return (&op->aio): 0;
 	storeBfUpdateOffset (bfstate);
+#if defined( DISK_REPL )
+	if( fd_table[ bfstate->fd ].swap_dir != sio -> swap_dirn )
+	  {
+	    debug( 81, 9 )( "BFREAD: swap_dir anomaly: fd: %i\n", bfstate->fd );
+	    print_fde( &fd_table[ bfstate->fd ] );
+	    debug( 81, 9 ) ( "op: %s", storeBfOpDump( op ) );
+	  }
+	else
+#endif
+	  {
+	    callReadHook( bfstate->fd, &x );
+	  }
 	if (! bfstate->aborting && cbdataValid(op->callback_data))
 	    op->callback.read (op->callback_data, op->aio.aio_buf, rlen);
 	cbdataUnlock (op->callback_data);
@@ -582,6 +603,18 @@
 	    storeBfIOAbort (sio, op->type, x);
 	op->rlen = (x == 0)? aio_return (&op->aio): 0;
 	storeBfUpdateOffset (bfstate);
+#if defined( DISK_REPL )
+	if( fd_table[ bfstate->fd ].swap_dir != sio -> swap_dirn )
+	  {
+	    debug( 81, 9 )( "BFWRITE: swap_dir anomaly: fd: %i\n", bfstate->fd );
+	    print_fde( &fd_table[ bfstate->fd ] );
+	    debug( 81, 9 ) ( "op: %s", storeBfOpDump( op ) );
+	  }
+	else
+#endif
+	  {
+		callWriteHook( bfstate->fd, &x );
+	  }
 	if (op->callback.write)
 	    op->callback.write (op->aio.aio_buf); /* free_func */
 	break;
